function [fluid previousA testdata]=energy2(fluid,previousA,previousD)
global pipeline;
global gas;
global xScale;
global K;
% iterator=1;
% for j=2:2:pipeline.nodes*2-1
%     tmp.velocity(j-1)=fluid.velocity(iterator);
%     tmp.velocity(j)=0.5*(fluid.velocity(iterator)+fluid.velocity(iterator+1));
%     tmp.density(j-1)=fluid.density(iterator);
%     tmp.density(j)=0.5*(fluid.density(iterator)+fluid.density(iterator+1));
%     tmp.pressure(j-1)=fluid.pressure(iterator);
%     tmp.pressure(j)=0.5*(fluid.pressure(iterator)+fluid.pressure(iterator+1));
%     tmp.Z(j-1)=fluid.Z(iterator);
%     tmp.Z(j)=0.5*(fluid.Z(iterator)+fluid.Z(iterator+1));
%     iterator=iterator+1;
% end
% tmp.velocity(pipeline.nodes*2-1)=fluid.velocity(pipeline.nodes);
% tmp.density(pipeline.nodes*2-1)=fluid.density(pipeline.nodes);
% tmp.pressure(pipeline.nodes*2-1)=fluid.pressure(pipeline.nodes);
% tmp.Z(pipeline.nodes*2-1)=fluid.Z(end);

T_new=fluid.temperature;
delta_time=fluid.time-previousA.time;
HeatConvection=zeros(1,pipeline.nodes-1);
Dissipation=zeros(1,pipeline.nodes-1);
for i=2:pipeline.nodes

        pipeSegment=ceil(i/(pipeline.nodesPrDx));
        burial=pipeline.burialType(pipeSegment);
        T_env=outsideTemperatures(burial);
%         U_avg=0.5*(fluid.velocity(i)+previousA.velocity(i-1));
%         rho_avg=0.5*(fluid.density(i)+previousA.density(i-1));
%         my=viscosity(fluid.temperature(i),rho_avg);
%         f_P=frictionfactor(fluid.velocity(i),fluid.density(i),fluid.temperature(i));
%         f_A=frictionfactor(previousA.velocity(i-1),previousA.density(i-1),previousA.temperature(i-1));
%         f_avg=0.5*(f_P+f_A);
%         [cp_new, cv_new]=specificHeat(T_new(i),fluid.pressure(i));
%         [cp_old, cv_old]=specificHeat(previousA.temperature(i-1),previousA.pressure(i-1));
%         Cp_gas_avg=0.5*(cp_new+cp_old);         
%         U_Wtot=overallHeatTransfer(U_avg,burial,rho_avg,my,Cp_gas_avg,i);
   
        if i==2
            velocityGrad_old=(1/(2*pipeline.dx))*(previousA.velocity(i+1)-previousA.velocity(i-1));
            velocityGrad_new=(1/(2*pipeline.dx))*(fluid.velocity(i+1)-fluid.velocity(i-1));
         elseif i==pipeline.nodes
            velocityGrad_old=(1/(2*pipeline.dx))*(previousA.velocity(i)-previousA.velocity(i-2)); 
            velocityGrad_new=(1/(2*pipeline.dx))*(fluid.velocity(i)-fluid.velocity(i-2));
         else
            velocityGrad_old=(1/(2*pipeline.dx))*(previousA.velocity(i)-previousA.velocity(i-2));
            velocityGrad_new=(1/(2*pipeline.dx))*(fluid.velocity(i+1)-fluid.velocity(i-1));
        end

        % alternative newton iteration
%         error=inf;
%         T_prev=T_new(i);
%         iter=0;
%         while error>1e-5
% %             A1=tmp.density(i)*cv_new*T_new(i)
% %             A2=previousA.density(i-1)*cv_old*fluid.temperature(i-1)
% %             B1=(tmp.density(i)*tmp.Z(i)*gas.R*velocityGrad_new*fluid.time*T_new(i))
% %             B2=previousA.density(i-1)*previousA.Z(i-1)*gas.R*velocityGrad_old*previousA.time*fluid.temperature(i-1)
% %             C1=1/(2*pipeline.diameter)*tmp.density(i)*f_P*tmp.velocity(i)^2*((i-1)*20)
% %             C2=1/(2*pipeline.diameter)*previousA.density(i-1)*f_A*previousA.velocity(i-1)^2*((i-2)*20)
% %             D=4*U_Wtot/pipeline.diameter*((T_new(i)-T_env)*fluid.time-(fluid.temperature(i-1)-T_env)*previousA.time)
%             func=tmp.density(i)*cv_new*T_new(i)-previousA.density(i-1)*cv_old*fluid.temperature(i-1)+...
%                 (tmp.density(i)*tmp.Z(i)*gas.R*velocityGrad_new*fluid.time*T_new(i)-...
%                 previousA.density(i-1)*previousA.Z(i-1)*gas.R*velocityGrad_old*previousA.time*fluid.temperature(i-1))-...
%                 1/(2*pipeline.diameter)*(tmp.density(i)*f_P*tmp.velocity(i)^2*((i-1)*20)-...
%                 previousA.density(i-1)*f_A*previousA.velocity(i-1)^2*((i-2)*20))+...
%                 4*U_Wtot/pipeline.diameter*((T_new(i)-T_env)*fluid.time-(fluid.temperature(i-1)-T_env)*previousA.time);
%             funcDeriv=tmp.density(i)*cv_new+...
%                 tmp.density(i)*tmp.Z(i)*gas.R*velocityGrad_new*fluid.time+...
%                 4*U_Wtot/pipeline.diameter;
%             T_new(i)=fluid.temperature(i)-func/funcDeriv;
%             error=abs(T_new(i)-T_prev);
%             T_prev=T_new;
%             iter=iter+1;
%             if iter>100
%                 disp('no convergence')
%                 break
%             end             
%         end

%       testshit
        velocityGrad=0.5*(velocityGrad_new+velocityGrad_old);
        U_avg=0.5*(fluid.velocity(i)+previousA.velocity(i-1));
        rho=0.5*(fluid.density(i)+previousA.density(i-1));
        Zfact=0.5*(fluid.Z(i)+previousA.Z(i-1));
        [cp_old, cv_old]=specificHeat(previousA.temperature(i-1),previousA.pressure(i-1));
       rho1=fluid.density(i);
       rho2=fluid.density(i-1);
% 
error=inf;
Tprev=fluid.temperature(i);
Iter=1;
while error>1e-5
        [cp_new, cv_new]=specificHeat(T_new(i),fluid.pressure(i));
        cv=0.5*(cv_new+cv_old);
        Temp=0.5*(fluid.temperature(i-1)+T_new(i));
        ff=frictionfactor(U_avg,rho,Temp);
        cp=0.5*(cp_new+cp_old);
        my=viscosity(Temp,rho);
        U_Wtot=overallHeatTransfer(U_avg,burial,rho,my,cp);
        
Ap_tmp=rho*cv+rho*Zfact*gas.R*velocityGrad*fluid.time+4*U_Wtot*fluid.time/pipeline.diameter;
Aa_tmp=rho*cv+rho*Zfact*gas.R*velocityGrad*previousA.time+4*U_Wtot*previousA.time/pipeline.diameter;
diss=rho*ff*U_avg^3/(2*pipeline.diameter)*(delta_time);
env=4*U_Wtot/pipeline.diameter*T_env*delta_time;
temperature=fluid.temperature(i-1);
T_new(i)=1/Ap_tmp*(Aa_tmp*temperature+diss+env);
error=norm(T_new(i)-Tprev);
Tprev=T_new(i);
Iter=Iter+1;
% if i==190
% i_tmp=i
% rho_tmp=rho
% cv_tmp=cv
% Zfact_tmp=Zfact
% velocityGrad_tmp=velocityGrad
% U_Wtot_tmp=U_Wtot
% elseif i==191
% i-i_tmp
% rho-rho_tmp
% cv-cv_tmp
% Zfact-Zfact_tmp
% velocityGrad
% velocityGrad-velocityGrad_tmp
% U_Wtot-U_Wtot_tmp
% end
if Iter>50
    disp('no convergence??')
    break
end
end

Dissipation(i-1)=diss;
HeatConvection(i-1)=env;
Ap(i-1)=Ap_tmp;
Aa(i-1)=Aa_tmp;

%--------------------------------------------------------------------------

%        Ap1=fluid.density(i)*cv_new;
%        Ap2=fluid.density(i)*fluid.Z(i)*gas.R*velocityGrad_new*fluid.time;
%        Ap3=4*(U_Wtot/pipeline.diameter)*fluid.time;
%        Ap(i)=Ap1+Ap2+Ap3;
% %        Ap(i)=tmp.density(i)*cv_new+tmp.density(i)*tmp.Z(i)*gas.R*velocityGrad_new*fluid.time+...
% %            4*(U_Wtot/pipeline.diameter)*fluid.time;
%         rho_A=previousA.density(i-1)+(previousA.density(i)-previousA.density(i-1))/...
%             pipeline.dx*(pipeline.dx-U_avg*delta_time);
%         Aa1=rho_A*cv_old;
% %         Aa1=previousA.density(i-1)*cv_old;
%         Z_A=previousA.Z(i-1)+(previousA.Z(i)-previousA.Z(i-1))/...
%             pipeline.dx*(pipeline.dx-U_avg*delta_time);
%         Aa2=rho_A*Z_A*gas.R*velocityGrad_old*previousA.time;
% %         Aa2=previousA.density(i-1)*previousA.Z(i-1)*gas.R*velocityGrad_old*previousA.time;
%         Aa3=4*U_Wtot/pipeline.diameter*previousA.time;
%         Aa(i)=Aa1+Aa2+Aa3;
% 
%         Dissipation(i-1)=(rho_avg*f_avg*U_avg^2/2/pipeline.diameter)*pipeline.dx;
%        HeatConvection(i-1)=(4*U_Wtot/pipeline.diameter)*(T_env*delta_time);
%         T_new(i)=(1/Ap(i))*(Aa(i)*previousA.temperature(i-1)+Dissipation(i-1)+HeatConvection(i-1));

end

previousD.density=previousA.density;
previousD.pressure=previousA.pressure;
previousD.temperature=previousA.temperature;
previousD.velocity=previousA.velocity;
previousD.time=previousA.time;

previousA.density=fluid.density;
previousA.pressure=fluid.pressure;
previousA.temperature=fluid.temperature;
previousA.velocity=fluid.velocity;
previousA.time=fluid.time;
fluid.temperature=T_new;
% figure(10)
% plot(Ap,'.-')
% hold on
% plot(Aa,'r')
% legend('Ap','Aa')
testdata.Ap=Ap;
testdata.Aa=Aa;
testdata.Ap=Ap;
testdata.Dissipation=Dissipation;
testdata.HeatConvection=HeatConvection;
end