function [pressure_in pressure_out flow_in temperature]=boudaryAdapt...
    (PinRemove,PoutRemove,ReqFlowLength,ReqPressLength,...
    pressure_in,pressure_out,flow_in,temperature,simTime)
% global sim_time;
for II=1:PinRemove
    tempval=ceil(rand(1)*(numel(pressure_in)-II));
    pressure_in(tempval)=[];
end
for JJ=1:PoutRemove
    tempval=ceil(rand(1)*(numel(pressure_out)-JJ));
    pressure_out(tempval)=[];
end

if PinRemove<0 || PoutRemove<0
    if PinRemove<0
        pressure_in=expand(pressure_in,(ReqPressLength));
    elseif PoutRemove<0
        pressure_out=expand(pressure_out,(ReqPressLength));
    end
end

if numel(flow_in)<ReqFlowLength
    flow_in=expand(flow_in,ReqFlowLength);
elseif numel(flow_in)>ReqFlowLength
    for KK=1:(numel(flow_rate_in)-ReqFlowRate)
        temp=ceil(rand(1)*(numel(flow_rate_in)-KK));
        flow_in(temp)=[];
        %flow_in=flow_rate_in;
    end
else
end
if temperature.constAtEnd==0
    reqLenT_in=temperature.readingPrMin*simTime*60+1;
else
    reqLenT_in=temperature.readingPrMin*temperature.constAtEnd*60+1;
end

if numel(temperature.in)>reqLenT_in
    for i=1:(numel(temperature.in)-reqLenT_in)
        temp=ceil(rand(1)*(numel(temperature.in)-i));
        if temp==0
            temp=round(rand(1)*60);
        end
        temperature.in(temp)=[];
    end
    
elseif numel(temperature.in)<reqLenT_in
    temperature.in=expand(temperature.in,reqLenT_in);
end
if temperature.constAtEnd~=0
    tempNumAdd=(simTime-temperature.constAtEnd)*temperature.readingPrMin*60;
    tempTin=zeros(numel(temperature.in)+tempNumAdd,1);
    tempTin(1:numel(temperature.in))=temperature.in;
    tempTin(numel(temperature.in)+1:end)=ones(tempNumAdd,1)*temperature.in(end);
    temperature.in=tempTin;
end
% temperature_in=temperature.in;
end