function dZdT=DranchukAbouKassemZderivative(Tpr,p_pr,Z)
global gas;
a=[0.3265;-1.0700;-0.5339;0.01569;...
    -0.05165;0.5475;-0.7361;0.1844;...
    0.1056;0.6134;0.7210];

rho_r=0.27*p_pr/Z/Tpr;
iterator=1;
drho_r=1;
dZtemp=1e-3;
error=inf;
while error>1e-4
    dZdTpr=a(1)*drho_r+a(2)*(drho_r-rho_r/Tpr)*(1/Tpr)+a(3)*(drho_r-3*rho_r/Tpr)*(1/Tpr^3)+...
        a(4)*(drho_r-4*rho_r/Tpr)*(1/Tpr^4)+a(5)*(drho_r-5*rho_r/Tpr)*(1/Tpr^5)+...
        2*a(6)*rho_r*drho_r+a(7)*rho_r*(2*drho_r-rho_r/Tpr)*(1/Tpr)+...
        2*a(8)*rho_r*(drho_r-rho_r/Tpr)*(1/Tpr^2)...
        -a(7)*a(9)*rho_r^4*(5*drho_r-rho_r/Tpr)*(1/Tpr)...
        -a(8)*a(9)*rho_r^4*(5*drho_r-2*rho_r/Tpr)*(1/Tpr^2)+...
        a(10)*rho_r*(2*drho_r-3*rho_r/Tpr-2*a(11)*rho_r^2*drho_r)*exp(-a(11)*rho_r^2)/Tpr^3+...
        a(10)*a(11)*rho_r^3*(4*drho_r-3*rho_r/Tpr-2*a(11)*rho_r^2*drho_r)*exp(-a(11)*rho_r^2)/Tpr^3;

    drho_r=-rho_r*(1/Tpr+1/Z*dZdTpr);
    error=norm(dZdTpr-dZtemp);
    dZtemp=dZdTpr;
    if iterator>100
        disp('could not find a proper correlation to dZdT');
        break
    end
end
dTprdT=1/gas.Tc;
dZdT=dZdTpr*dTprdT;
return